/* File operations */
/* Access a file in a different way from which has been opened problem */
/* Context sensitive example */
/* Function pointers */

#include "stdio.h"

FILE *file_open(const char *fname, const char *mode)
{
	return fopen(fname,mode);
}

int file_getc(FILE *ptr)
{
	return fgetc(ptr);	
}

int file_putc(FILE *ptr, int val)
{
	return fputc(val,ptr); 	
}

void file_close(FILE *ptr)
{
        if(ptr) fclose(ptr);
}

int main()
{
        FILE *fp;
	int c1;
        int c2 = (int) 'd';

	FILE* (*file_open_ptr)(const char*,const char*) = 0;
	int (*file_getc_ptr)(FILE*) = 0;
	int (*file_putc_ptr)(FILE*,int) = 0;
	void (*file_close_ptr)(FILE*) = 0;

	file_open_ptr = &file_open;
	file_getc_ptr = &file_getc;
	file_putc_ptr = &file_putc;
	file_close_ptr = &file_close;

	fp = (*file_open_ptr)("file1.txt","r");
	
	if(fp) c1 = (*file_getc_ptr)(fp);	/* OK */

	if(fp) (*file_putc_ptr)(fp,c2);		/* DANGER */

	if(fp) (*file_close_ptr)(fp);
	
	return 1;
}
