/* File operations */
/* Access a file in a different way from which has been opened problem */
/* Context sensitive example */
/* Unions */

#include "stdio.h"

struct sample {
	union {
		FILE *fp;
	} un1;
};

FILE *file_open(const char *fname, const char *mode)
{
	return fopen(fname,mode);
}

int file_getc(FILE *ptr)
{
	return fgetc(ptr);	
}

int file_putc(FILE *ptr, int val)
{
	return fputc(val,ptr); 	
}

void file_close(FILE *ptr)
{
        if(ptr) fclose(ptr);
}

int main()
{
	struct sample sct;
	int c1;
        int c2 = (int) 'd';

	sct.un1.fp = file_open("file1.txt","r");
	
	if(sct.un1.fp) c1 = file_getc(sct.un1.fp);	/* OK */

	if(sct.un1.fp) file_putc(sct.un1.fp,c2);	/* DANGER */

	if(sct.un1.fp) file_close(sct.un1.fp);
	
	return 1;
}
